#include <src/fm.h>

void fMain::configLoad(QString device){
// Загрузка файла конфигурации
	QString configFile=HomeDir+"/.tvok/tvok"+device+".rc";
	QSettings cfg (configFile,QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	int h,w,x,y;
	cfg.beginGroup ("MainWindow");
		h=cfg.value ("Height",290).toInt();
		w=cfg.value ("Width",325).toInt();
		int deltaY=cfg.value ("deltaY",10).toInt();
		x=cfg.value ("posX",10).toInt();
		y=cfg.value ("posY",10).toInt()-deltaY;
		confPanel->cpDefaultWidth->setValue (cfg.value ("defaultWidth",326).toInt());
		confPanel->cpDefaultHeight->setValue (cfg.value ("defaultHeight",300).toInt());
	cfg.endGroup();
	move (x,y);
	resize (w,h);
	cfg.beginGroup ("Main");
		CurrentChannel=cfg.value ("CurrentChannel",1).toInt();
		LastChannel=cfg.value ("LastChannel",1).toInt();
		if (CurrentChannel > LastChannel) CurrentChannel = 1;
		mplayerOsd=cfg.value ("OSD",true).toBool();
	cfg.endGroup();
	cfg.beginGroup ("Presets");
		confPanel->cpPresets->clear();
		int PresetsCount = cfg.value ("Count",0).toInt();
		for (int i=0;i<PresetsCount;i++){
			QString sI;
			sI.setNum (i);
			confPanel->cpPresets->addItem (cfg.value (sI+"/Name").toString());
			}
		confPanel->cpPresets->setCurrentIndex (cfg.value ("Current",0).toInt());
	cfg.endGroup();
	if (PresetsCount == 0){
		QString defaultPreset=tr ("Default preset");
		confPanel->cpPresets->addItem (defaultPreset);
		confPanel->cpPresets->setCurrentIndex (confPanel->cpPresets->count()-1);
		savePreset (confPanel->cpPresets->count()-1);
		} else {
		loadPreset (confPanel->cpPresets->currentIndex());
		}
	Channels.clear();
	Channel ChannelLoad;
	for (int i=0; i<LastChannel;i++){
		cfg.beginGroup ("Channel"+QString::number(i));
		ChannelLoad.freq=cfg.value("freq","135.25").toString();
		ChannelLoad.norm=cfg.value("norm","PAL").toString();
		ChannelLoad.descr=cfg.value("descr",tr("No name")).toString();
		ChannelLoad.brightness=cfg.value("brightness",0).toInt();
		ChannelLoad.contrast=cfg.value("contrast",0).toInt();
		ChannelLoad.saturation=cfg.value("saturation",0).toInt();
		ChannelLoad.icon=NULL;
		ChannelLoad.icon.load (HomeDir+"/.tvok/ChannelsLogo/"+ChannelLoad.descr+".png");
		ChannelLoad.groupId=cfg.value("GroupId",0).toInt();
		ChannelLoad.zoom=cfg.value("Zoom",1.89).toDouble();
		cfg.endGroup();
		Channels.append(ChannelLoad);
		}

//	if (CropEnabled) confPanel->cpCropEnabled->setCheckState (Qt::Checked);
//		else confPanel->cpCropEnabled->setCheckState (Qt::Unchecked);
	if (ResizeEnabled) confPanel->cpResizeEnabled->setCheckState (Qt::Checked);
		else confPanel->cpResizeEnabled->setCheckState (Qt::Unchecked);
	if (RVideoFiltersEnabled) confPanel->cpRVideoFiltersEnabled->setCheckState (Qt::Checked);
		else confPanel->cpRVideoFiltersEnabled->setCheckState (Qt::Unchecked);
	if (VVideoFiltersEnabled) confPanel->cpVVideoFiltersEnabled->setCheckState (Qt::Checked);
		else confPanel->cpVVideoFiltersEnabled->setCheckState (Qt::Unchecked);
	if (RAudioFiltersEnabled) confPanel->cpRAudioFiltersEnabled->setCheckState (Qt::Checked);
		else confPanel->cpRAudioFiltersEnabled->setCheckState (Qt::Unchecked);
	oprint (tr ("Settings loaded for device")+" \""+confPanel->cpVideoDevicePrefix->text()+device+"\" "+tr ("from file")+" \""+cfg.fileName()+"\".");
}

void fMain::configSave(){
// Запись файла конфигурации
	QString configFile=HomeDir+"/.tvok/tvok"+device+".rc";
	QSettings cfg (configFile,QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	cfg.beginGroup ("MainWindow");
		if (!FullScreenFlag){
			if (!dOff){
				cfg.setValue ("Height", height());
				cfg.setValue ("Width", width());
				}
			cfg.setValue ("posX", x());
			cfg.setValue ("posY", y());
			cfg.setValue ("defaultWidth", confPanel->cpDefaultWidth->value());
			cfg.setValue ("defaultHeight", confPanel->cpDefaultHeight->value());
//			cfg.setValue ("Palette",palette());
		}
	cfg.endGroup();
	cfg.beginGroup ("Main");
		cfg.setValue ("CurrentChannel", CurrentChannel);
		cfg.setValue ("LastChannel", LastChannel);

	cfg.endGroup();
	cfg.beginGroup ("Presets");
		if (!TemporaryPreset){
			cfg.setValue ("Count",confPanel->cpPresets->count());
			cfg.setValue ("Current",confPanel->cpPresets->currentIndex());
			savePreset (confPanel->cpPresets->currentIndex());
			}
		for (int j=0;j<confPanel->cpPresets->count();j++){
			QString sJ;
			sJ.setNum (j);
			cfg.setValue (sJ+"/Name",confPanel->cpPresets->itemText(j));
			}
	cfg.endGroup();
	for (int i=0; i<LastChannel;i++){
		cfg.beginGroup ("Channel"+QString::number(i));
		cfg.setValue ("freq",Channels[i].freq);
		cfg.setValue ("norm",Channels[i].norm);
		cfg.setValue ("descr",Channels[i].descr);
		cfg.setValue ("brightness",Channels[i].brightness);		
		cfg.setValue ("contrast",Channels[i].contrast);		
		cfg.setValue ("saturation",Channels[i].saturation);		
		cfg.setValue ("GroupId",Channels[i].groupId);		
		cfg.setValue ("Zoom",Channels[i].zoom);		
		cfg.endGroup();
		}
//	oprint (tr ("Settings saved for device")+" \""+confPanel->cpVideoDevicePrefix->text()+device+"\" "+tr ("to file")+" \""+cfg.fileName()+"\".");
}

void fMain::loadPreset(int index){
	QString configFile=HomeDir+"/.tvok/tvok"+device+".rc";
	QSettings cfg (configFile,QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	cfg.beginGroup ("Presets");
		QString sI;
		sI.setNum (index);
		confPanel->cpCropBottom->setValue (cfg.value (sI+"/cropBottom",8).toInt());
		confPanel->cpCropLeft->setValue (cfg.value (sI+"/cropLeft",8).toInt());
		confPanel->cpCropRight->setValue (cfg.value (sI+"/cropRight",8).toInt());
		confPanel->cpCropTop->setValue (cfg.value (sI+"/cropTop",8).toInt());
		confPanel->cpCropBottomR->setValue (cfg.value (sI+"/cropBottomR",8).toInt());
		confPanel->cpCropLeftR->setValue (cfg.value (sI+"/cropLeftR",8).toInt());
		confPanel->cpCropRightR->setValue (cfg.value (sI+"/cropRightR",8).toInt());
		confPanel->cpCropTopR->setValue (cfg.value (sI+"/cropTopR",8).toInt());
//		CropEnabled=cfg.value (sI+"/CropEnabled",true).toBool();
		VVideoFiltersEnabled=cfg.value (sI+"/vVideoFiltersEnabled",true).toBool();
		RVideoFiltersEnabled=cfg.value (sI+"/rVideoFiltersEnabled",true).toBool();
		confPanel->cpRecordDir->setText (cfg.value (sI+"/RecordDir",HomeDir).toString());
		confPanel->cpVideoDevicePrefix->setText (cfg.value (sI+"/VideoDevicePrefix","/dev/video").toString());
			if (confPanel->cpVideoDevicePrefix->text() == "" ) confPanel->cpVideoDevicePrefix->setText ("/dev/video");
		confPanel->cpVVideoFilters->setText (cfg.value (sI+"/vVideoFilters","pp=fd,hqdn3d").toString());
		confPanel->cpPSpeed->setText (cfg.value (sI+"/Speed","0.998").toString());
		confPanel->cpPDelay->setValue (cfg.value (sI+"/Delay",1000).toInt());
		confPanel->cpVideoFilters->setText (cfg.value (sI+"/rVideoFilters","pp=fd/ac,hqdn3d").toString());
		confPanel->cpFps->setText (cfg.value (sI+"/Fps","25.000").toString());
		confPanel->cpVideoCodec->setText (cfg.value (sI+"/rVideoCodec","vcodec=mjpeg:vbitrate=2000:keyint=1").toString());
		confPanel->cpAudioDev->setCurrentIndex (cfg.value (sI+"/AudioDev",0).toInt());
		confPanel->cpAudioInput->setText (cfg.value (sI+"/rAudioInput","/dev/dsp").toString());
		confPanel->cpAudioDelay->setText (cfg.value (sI+"/AudioDelay","0").toString());
		confPanel->cpAudioFreq->setText (cfg.value (sI+"/AudioFreq","32000").toString());
		confPanel->cpAudioVolume->setText (cfg.value (sI+"/AudioVolume","10:0").toString());
		confPanel->cpRAudioFilters->setText (cfg.value (sI+"/AudioFilters","").toString());
		RAudioFiltersEnabled=cfg.value (sI+"/rAudioFiltersEnabled",false).toBool();
		confPanel->cpAudioCodec->setText (cfg.value (sI+"/AudioCodec","pcm").toString());
		confPanel->cpROtherParameters->setText (cfg.value (sI+"/OtherParameters","-noskip -mc 0 -noodml").toString());
		confPanel->cpFileExt->setText (cfg.value (sI+"/FileExtention",".avi").toString());
		confPanel->cpSizeHeight->setValue (cfg.value (sI+"/sizeHeight",240).toInt());
		confPanel->cpSizeWidth->setValue (cfg.value (sI+"/sizeWidth",320).toInt());
		ResizeEnabled=cfg.value (sI+"/ResizeEnabled",true).toBool();
		confPanel->cpVOtherParameters->setText (cfg.value (sI+"/MplayerOtherParameters","").toString());
		confPanel->cpTVParameters->setText (cfg.value (sI+"/TVParameters","").toString());
	cfg.endGroup();
	confPanel->cpPresets->setCurrentIndex (index);
	oprint (tr ("Load presets")+" \""+confPanel->cpPresets->itemText(index)+"\"");
}

void fMain::savePreset(int index){
	setCheckBoxes();
	QString configFile=HomeDir+"/.tvok/tvok"+device+".rc";
	QSettings cfg (configFile,QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	cfg.beginGroup ("Presets");
		if (confPanel->cpPresets->count() == 0) confPanel->cpPresets->addItem (tr ("Default presets"));
		QString sI;
		sI.setNum (index);
		cfg.setValue (sI+"/Name",confPanel->cpPresets->itemText(index));
		cfg.setValue (sI+"/cropBottom", confPanel->cpCropBottom->value());
		cfg.setValue (sI+"/cropLeft", confPanel->cpCropLeft->value());
		cfg.setValue (sI+"/cropRight", confPanel->cpCropRight->value());
		cfg.setValue (sI+"/cropTop", confPanel->cpCropTop->value());
		cfg.setValue (sI+"/cropBottomR", confPanel->cpCropBottomR->value());
		cfg.setValue (sI+"/cropLeftR", confPanel->cpCropLeftR->value());
		cfg.setValue (sI+"/cropRightR", confPanel->cpCropRightR->value());
		cfg.setValue (sI+"/cropTopR", confPanel->cpCropTopR->value());
//		cfg.setValue (sI+"/CropEnabled", CropEnabled);
		cfg.setValue (sI+"/vVideoFiltersEnabled", VVideoFiltersEnabled);
		cfg.setValue (sI+"/rVideoFiltersEnabled", RVideoFiltersEnabled);
		cfg.setValue (sI+"/RecordDir", confPanel->cpRecordDir->text());
		cfg.setValue (sI+"/VideoDevicePrefix", confPanel->cpVideoDevicePrefix->text());
		cfg.setValue (sI+"/Speed",confPanel->cpPSpeed->text());
		cfg.setValue (sI+"/Delay",confPanel->cpPDelay->text());
		cfg.setValue (sI+"/vVideoFilters",confPanel->cpVVideoFilters->text());
		cfg.setValue (sI+"/AudioVolume",confPanel->cpAudioVolume->text());
		cfg.setValue (sI+"/AudioFreq",confPanel->cpAudioFreq->text());
		cfg.setValue (sI+"/AudioDelay",confPanel->cpAudioDelay->text());
		cfg.setValue (sI+"/rVideoCodec",confPanel->cpVideoCodec->text());
		cfg.setValue (sI+"/Fps",confPanel->cpFps->text());
		cfg.setValue (sI+"/rVideoFilters",confPanel->cpVideoFilters->text());
		cfg.setValue (sI+"/rAudioInput",confPanel->cpAudioInput->text());
		cfg.setValue (sI+"/AudioDev",confPanel->cpAudioDev->currentIndex());
		cfg.setValue (sI+"/rVideoFilters",confPanel->cpVideoFilters->text());
		cfg.setValue (sI+"/AudioFilters",confPanel->cpRAudioFilters->text());
		cfg.setValue (sI+"/rAudioFiltersEnabled", RAudioFiltersEnabled);
		cfg.setValue (sI+"/AudioCodec",confPanel->cpAudioCodec->text());
		cfg.setValue (sI+"/OtherParameters",confPanel->cpROtherParameters->text());
		cfg.setValue (sI+"/FileExtention",confPanel->cpFileExt->text());
		cfg.setValue (sI+"/sizeHeight", confPanel->cpSizeHeight->value());
		cfg.setValue (sI+"/sizeWidth", confPanel->cpSizeWidth->value());
		cfg.setValue (sI+"/ResizeEnabled", ResizeEnabled);
		cfg.setValue (sI+"/MplayerOtherParameters",confPanel->cpVOtherParameters->text());
		cfg.setValue (sI+"/TVParameters",confPanel->cpTVParameters->text());
	cfg.endGroup();
	oprint (tr ("Save presets")+" \""+confPanel->cpPresets->itemText(index)+"\"");
}

void fMain::deletePreset(int index){
	if (index != 0){
		QString sp=confPanel->cpPresets->itemText(index);
		QString configFile=HomeDir+"/.tvok/tvok"+device+".rc";
		QSettings cfg (configFile,QSettings::NativeFormat);
		cfg.setIniCodec ("UTF-8");
		QString sI;
		sI.setNum (index);
		cfg.beginGroup ("Presets");
			cfg.remove (sI);
			confPanel->cpPresets->removeItem (index);
			confPanel->cpPresets->setCurrentIndex (0);
			cfg.setValue ("Count",confPanel->cpPresets->count());
			cfg.setValue ("Current",confPanel->cpPresets->currentIndex());
		cfg.endGroup();
		configLoad (device);
		oprint (tr ("Delete presets")+" \""+sp+"\"");
		}
}
