#include <src/fm.h>

void fMain::deltaChannel(int delta){
// Колесо мышы
	if (prRecord.state()!=QProcess::Running){
		if (delta > 0) ChannelNext();
		else ChannelPrev();
		}
}

void fMain::ChannelNext(){
	if (prView.state() == QProcess::Running){
		videoFrameOff();
		int ch;
		if (CurrentChannel > LastChannel-1) ch=0;
		else ch=CurrentChannel;
		ChannelChange (ch);
		}
}

void fMain::ChannelPrev(){
	if (prView.state() == QProcess::Running){
		videoFrameOff();
		int ch;
		if (CurrentChannel < 2) ch=LastChannel-1;
		else ch=CurrentChannel-2;
		ChannelChange (ch);
	}
}

void fMain::ChannelChange(int id){
	channelId=id;
	timerChannelChange2->singleShot (100, this, SLOT (ChannelChangeDelay ()));
}

void fMain::ChannelChangeDelay(){
// Переключение канала по id
	int id=channelId;
	if (!PidExists){
		CurrentChannel=id+1;
		setFreq (Channels[id].freq);
		setNorm (Channels[id].norm);
		confPanel->cpDescr->setText(Channels[id].descr);
		confPanel->cpFreq->setValue(Channels[id].freq.toFloat());
		confPanel->cpNorm->setCurrentIndex (confPanel->cpNorm->findText (Channels[id].norm));
		confPanel->cpBrightnessSlider->setValue(Channels[id].brightness);
		confPanel->cpBrightnessSpin->setValue(Channels[id].brightness);
		setBrightness (Channels[id].brightness);
		confPanel->cpContrastSlider->setValue(Channels[id].contrast);
		confPanel->cpContrastSpin->setValue(Channels[id].contrast);
		setContrast (Channels[id].contrast);
		confPanel->cpSaturationSlider->setValue(Channels[id].saturation);
		confPanel->cpSaturationSpin->setValue(Channels[id].saturation);
		setSaturation (Channels[id].saturation);
		mpCurrentChannel->setText(Channels[id].descr);
		confPanel->spZoom->setValue (Channels[id].zoom);
		setZoom(Channels[id].zoom);
		if (mplayerOsd){
			if (prView.state()==QProcess::Running){
				QString msw;
				msw.setNum (CurrentChannel);
				QString m="osd 1\nosd_show_text '"+msw+": "+Channels[id].descr+"' 5000\n";
				prView.write (m.toAscii());
				}
			}
		lChannel->setPixmap (Channels[id].icon);
		}
	setWindowTitle (Channels[id].descr+" (TVOK-"+device+")");
	configSave();
}

void fMain::videoFrameOn (){
	videoFrame->setVisible (true);
}

void fMain::videoFrameOff (){
	videoFrame->setVisible (false);
	timerChannelChange->singleShot (VIDEO_PANEL_OFF, this, SLOT (videoFrameOn()));
}

void fMain::ChannelChangeByName (QString descr){
// Переключение канала по имени
	videoFrameOff();
	ChannelChange (idChannel (descr));
}

int fMain::idChannel (QString descr){
// Получение id канала по имени
	int ch=0;
	for (int i=0;i<LastChannel;i++){
		if (Channels[i].descr == descr) ch=i;
		}
	return ch;
}

void fMain::setFreq(const QString& freq){
// Установка частоты
// freq = "212.25"...
	if (freq != "Composite"){
		struct v4l2_frequency sfreq;
		memset (&sfreq, 0, sizeof (sfreq));
		sfreq.type=V4L2_TUNER_ANALOG_TV;
		sfreq.frequency=freq.toDouble()*1000 / 62.5;
		ioctl (VDevice, VIDIOC_S_FREQUENCY, &sfreq);
		}
	Channels[CurrentChannel-1].freq=freq;
	ChannelsTableFill();
	confPanel->cpChannelsTable->selectRow (CurrentChannel-1);
}

void fMain::setNorm(const QString& norm){
// Установка стандарта вещания
// norm - "SECAM","PAL","NTSC"
	v4l2_std_id Norm;
	v4l2_std_id id=0;
	for (int i=0;i<standardsCount;i++){
		QString it;
		it.sprintf ("%s",Standards[i].name);
		if (it == norm){
			id=Standards[i].id;
			}
		}
	Norm=id;
	if (ioctl (VDevice, VIDIOC_S_STD, &Norm) == -1) {
		perror ("VIDIOC_S_STD");
		exit(tr ("V4L - set standard error."));
		}
	Channels[CurrentChannel-1].norm=norm;
	ChannelsTableFill();
	confPanel->cpChannelsTable->selectRow (CurrentChannel-1);
}

void fMain::setContrast(const int value){
// Установка контрастности
	struct v4l2_queryctrl queryctrl;
	struct v4l2_control control;
	memset (&queryctrl, 0, sizeof (queryctrl));
	queryctrl.id = V4L2_CID_CONTRAST;
	ioctl (VDevice, VIDIOC_QUERYCTRL, &queryctrl);
	memset (&control, 0, sizeof (control));
	control.id = V4L2_CID_CONTRAST;
	float koef=(queryctrl.maximum-queryctrl.minimum)/100.0;
	control.value = (value /2 + 50) * koef;
	if (ioctl (VDevice, VIDIOC_S_CTRL, &control) == -1) {
		perror ("VIDIOC_S_CTRL");
		exit (tr ("V4L - set contrast error."));
		}
	Channels[CurrentChannel-1].contrast=confPanel->cpContrastSlider->value();
}

void fMain::setBrightness(const int value){
// Установка яркости
	struct v4l2_queryctrl queryctrl;
	struct v4l2_control control;
	memset (&queryctrl, 0, sizeof (queryctrl));
	queryctrl.id = V4L2_CID_BRIGHTNESS;
	ioctl (VDevice, VIDIOC_QUERYCTRL, &queryctrl);
	memset (&control, 0, sizeof (control));
	control.id = V4L2_CID_BRIGHTNESS;
	float koef=(queryctrl.maximum-queryctrl.minimum)/100.0;
	control.value = (value /2 + 50) * koef;
	if (ioctl (VDevice, VIDIOC_S_CTRL, &control) == -1) {
		perror ("VIDIOC_S_CTRL");
		exit (tr ("V4L - set brightness error."));
		}
	Channels[CurrentChannel-1].brightness=confPanel->cpBrightnessSlider->value();
}

void fMain::setSaturation(const int value){
// Установка насыщености
	struct v4l2_queryctrl queryctrl;
	struct v4l2_control control;
	memset (&queryctrl, 0, sizeof (queryctrl));
	queryctrl.id = V4L2_CID_SATURATION;
	ioctl (VDevice, VIDIOC_QUERYCTRL, &queryctrl);
	memset (&control, 0, sizeof (control));
	control.id = V4L2_CID_SATURATION;
	float koef=(queryctrl.maximum-queryctrl.minimum)/100.0;
	control.value = (value /2 + 50) * koef;
	if (ioctl (VDevice, VIDIOC_S_CTRL, &control) == -1) {
		perror ("VIDIOC_S_CTRL");
		exit (tr ("V4L - set saturation error."));
		}
	Channels[CurrentChannel-1].saturation=confPanel->cpSaturationSlider->value();
}

void fMain::openV4Ldevice(){
	sVDevice=confPanel->cpVideoDevicePrefix->text()+device;
	VDevice=open (sVDevice.toAscii(), O_RDWR);
}

void fMain::getStandards(){
// Получение доступных стандартов
	v4l2_standard standard;
	standard.index = 0;
	while (0 == ioctl (VDevice, VIDIOC_ENUMSTD, &standard)) {
		if (standard.id) {
			Standards[standard.index]=standard;
			QString it;
			it.sprintf ("%s",Standards[standard.index].name);
			confPanel->cpNorm->addItem (it);
			confPanel->cpASStandard->addItem (it);
			}
		standard.index++;
		standardsCount=standard.index;
		}
}

void fMain::setDescr(){
	Channels[CurrentChannel-1].descr=confPanel->cpDescr->text();
	ChannelsTableFill();
	confPanel->cpChannelsTable->selectRow (CurrentChannel-1);
}

void fMain::ChannelsScan(){
// Автопоиск и добавление каналов
	viewStop();
	QString command="mplayer -quiet -wid "+videoFrameId+" -tvscan autostart:threshold=90 -tv norm="+confPanel->cpASStandard->currentText()+":device="+confPanel->cpVideoDevicePrefix->text()+device+" tv://";
	prScan.start (command);
	oprint (tr ("Start scanning")+": "+command);
	bool flag=true;
	QString prev="";
	QString now="";
	QString mess;
	int foundNew=0, foundExists=0;
	prScan.waitForReadyRead (1000);
	while (flag){
		qApp->processEvents();
		prScan.waitForReadyRead (1000);
		prev=now;
		QByteArray result = prScan.readAllStandardOutput();
		if (result.isEmpty()) flag=false;
		result.chop(2);
		now=QString(result);
		if (now.contains ("Found new channel:")){
			mess=prev.mid(prev.indexOf("(")+1,(prev.indexOf(")")-prev.indexOf("("))-1);
			if (mess.toFloat() > 40){
				int ch=ChannelExists(mess);
				Channel addCh;
				if (ch == -1){
					addCh.freq=QString::number(mess.toFloat());
					addCh.norm=confPanel->cpASStandard->currentText();
					addCh.brightness=0;
					addCh.contrast=0;
					addCh.saturation=0;
					addCh.icon=NULL;
					addCh.descr=tr ("No name")+"-"+confPanel->cpASStandard->currentText()+"-"+addCh.freq;
					addCh.groupId=0;
					Channels.append (addCh);
					LastChannel++;
					confPanel->cpChannelFound->setText(tr ("New channel")+": "+confPanel->cpASStandard->currentText()+"-"+addCh.freq);
					foundNew++;
					}
				else {
					confPanel->cpChannelFound->setText (tr ("Exists channel")+": "+Channels[ch].descr);
					foundExists++;
					}
				}
			}
		}
	prScan.terminate();
	prScan.waitForFinished (3000);
	viewStart();
	confPanel->cpChannelFound->setText (tr ("Found new")+": "+QString::number(foundNew)+", "+tr ("exists")+": "+QString::number(foundExists));
	ChannelsTableFill();
}

int fMain::ChannelExists (QString freq){
// Возвращает номер канала, если существует частота freq, иначе -1
	int ch=-1;
	for (int i=0;i<LastChannel;i++)
		if (Channels[i].freq.toFloat() == freq.toFloat())
			ch=i;
	return ch;
}

void fMain::ChannelsScanStop(){
qDebug ()<<"Scan stop";
	prScan.terminate();
	prScan.waitForFinished (3000);
	ChannelsTableFill();
	viewStart();
}

void fMain::ChannelChangeFromTable(){
	if (prRecord.state() != QProcess::Running){
		videoFrameOff();
		ChannelChange (confPanel->cpChannelsTable->currentRow());
		}
}

void fMain::ChannelNum(QString ch){
	if (prView.state()==QProcess::Running){
		if (((ch>=("0")) && (ch<=("9"))) || ch==("<")){
			if (ch==("<")){
				SelectChannel.chop (1);
				ch="";
				}
			SelectChannel=SelectChannel+ch;
			int id=SelectChannel.toInt()-1;
			if (id<0) id=0;
			if (id>LastChannel-1) id=LastChannel-1;
			QString msw;
			msw.setNum (WAIT_NEXT_DIGIT_DBUS);
			QString m="osd 1\nosd_show_text '"+SelectChannel+": "+Channels[id].descr+"' 5000\n";
			prView.write (m.toAscii());
			tSelectChannel->start (WAIT_NEXT_DIGIT_DBUS);
			}
		}
}

void fMain::tChSelectTimeout(){
	tSelectChannel->stop();
	int ch=SelectChannel.toInt()-1;
	if (ch < 0) ch=0;
	if (ch > LastChannel-1) ch=LastChannel-1;
	ChannelChange(ch);
	SelectChannel="";
}
