#include <src/fm.h>

// Проверка параметров командной строки и начальная инициализация. Вызывается из main.cpp
	if (qApp->argc()>1){
		for (int i=0;i<qApp->argc();i++){
			QString ar=qApp->argv()[i];
			if ((ar == "-dev") || (ar == "--dev")){
// Номер тюнера
// По умолчанию - 0.
				QString newDevice=qApp->argv()[i+1];
// Если тюнер изменился из командной строки - загружается конфигурация соответствующего тюнера
				if (newDevice != device){
					device=newDevice;
					oprint (fMain::tr ("The device changed from the command line")+".");
					configLoad (device);
					}
				}
			if ((ar == "-preset") || (ar == "--preset")){
// Предустановка
				TemporaryPreset=true;
				loadPreset (getIdPresetFromName (QString::fromLocal8Bit(qApp->argv()[i+1])));
				}
			if ((ar == "-rec") || (ar == "--rec")){
// Режим записи (+1 - имя канала, +2 - имя программы, +3 - продолжительность записи)
				CommandRec=true;
				prefChar=FILE_PREFIX_COMMAND"-";
				arCh=idChannel (QString::fromLocal8Bit(qApp->argv()[i+1]));
				arChStr=Channels[arCh].descr;
				arName=QString::fromLocal8Bit(qApp->argv()[i+2]);
				arTime=qApp->argv()[i+3];
// Если параметр продолжительности записи содержит "E" в первой позиции, окончание записи в это время.
// Например - "E23:15:00" - завершить запись в 23:15:00
				if (arTime.left(1) == "E"){
					arTime=QString::number (QTime::currentTime().secsTo (QTime::fromString (arTime.mid (1,20),"hh:mm:ss")));
					}
				oprint ("--------------------------------------------------------");
				oprint (fMain::tr ("Record starting")+":");
				oprint (fMain::tr ("Device")+": "+confPanel->cpVideoDevicePrefix->text()+device);
				oprint (fMain::tr ("Channel")+": "+arChStr);
				oprint (fMain::tr ("Transmission")+": "+arName);
				oprint (fMain::tr ("Duration")+": "+arTime);
				oprint ("--------------------------------------------------------");
				}
			if ((ar == "-doff") || (ar == "--doff")){
// Не выводить просмотр (не активировать MPlayer). Актуально только с ключом -r.
				dOff=true;
				}
			if ((ar == "-hp") || (ar == "--hp")){
// Высокий приоритет запуска
// Если установлен этот параметр, все новые экземпляры tvok не запускаются.
// Если уже есть запущенный tvok без этого параметра, он закрывается.
				HPrior=true;
				}
			}
		}
