#include "cpanel.h"
#include <QtGui>

cPanel::cPanel( QWidget * parent, Qt::WFlags f): QWidget(parent, f ){
	setupUi(this);
	PresetAdded=false;
}

cPanel::~cPanel(){
}

void cPanel::setRecDir(){
	QFileDialog fDial(this);
	QString rDir=fDial.getExistingDirectory (this, tr("Folder for capture"), cpRecordDir->text());
	if (rDir != "") cpRecordDir->setText (rDir);
}

void cPanel::changeBrightnessSpin(){
	cpBrightnessSlider->setValue (cpBrightnessSpin->value());
	emit setBrightness (cpBrightnessSpin->value());
}
void cPanel::changeBrightnessSlider(){
	cpBrightnessSpin->setValue (cpBrightnessSlider->value());
}

void cPanel::changeContrastSpin(){
	cpContrastSlider->setValue (cpContrastSpin->value());
	emit setContrast (cpContrastSpin->value());
}
void cPanel::changeContrastSlider(){
	cpContrastSpin->setValue (cpContrastSlider->value());
}

void cPanel::changeSaturationSpin(){
	cpSaturationSlider->setValue (cpSaturationSpin->value());
	emit setSaturation (cpSaturationSpin->value());
}
void cPanel::changeSaturationSlider(){
	cpSaturationSpin->setValue (cpSaturationSlider->value());
}

void cPanel::changeZoomSpin(){
	emit setZoom (spZoom->value());
}

void cPanel::changeDescr(){
	emit setDescr();
}

void cPanel::changeFreq(){
	emit setFreq(cpFreq->text());
}

void cPanel::changeNorm(){
	emit setNorm(cpNorm->currentText());
}

void cPanel::changeCheckBoxes(){
	emit setCheckBoxes();
}

void cPanel::changeDefaultSize(){
	emit setDefaultSize();
}

void cPanel::changeCurrentSize(){
	emit setCurrentSize();
}

void cPanel::pressedChannelsScan(){
	emit ChannelsScan();
}

void cPanel::pressedChannelsScanStop(){
	emit ChannelsScanStop();
}

void cPanel::pressedChannelAdd(){
	emit ChannelAdd();
}

void cPanel::pressedChannelDel(){
	emit ChannelDel();
}

void cPanel::pressedChannelUp(){
	emit ChannelUp();
}

void cPanel::pressedChannelDn(){
	emit ChannelDn();
}

void cPanel::changeTableItem(){
	emit ChannelChangeFromTable();
}

void cPanel::pressedAddPreset(){
	PresetAdded=true;
	cpPresets->addItem (cpPresets->currentText());
	cpPresets->setCurrentIndex (cpPresets->count()-1);
	emit savePreset (cpPresets->count()-1);
	PresetAdded=false;
}

void cPanel::pressedDelPreset(){
	emit deletePreset (cpPresets->currentIndex());
}

void cPanel::pressedApplyPreset(){
	cpPresets->setItemText (cpPresets->currentIndex(),cpPresets->currentText());
	emit savePreset (cpPresets->currentIndex());
}

void cPanel::changePreset(){
	if (!PresetAdded) emit loadPreset (cpPresets->currentIndex());
}
