#ifndef CPANEL_H
#define CPANEL_H

#include <QWidget>
#include "ui_config.h"

class cPanel : public QWidget, public Ui::Conf
{
Q_OBJECT
public slots:
	
private slots:
	void changeCurrentSize();
	void changeDefaultSize();
	void setRecDir();
	void changeBrightnessSpin();
	void changeBrightnessSlider();
	void changeContrastSpin();
	void changeContrastSlider();
	void changeSaturationSpin();
	void changeSaturationSlider();
	void changeDescr();
	void changeFreq();
	void changeNorm();
	void changeCheckBoxes();
	void pressedChannelsScan();
	void pressedChannelsScanStop();
	void pressedChannelAdd();
	void pressedChannelDel();
	void pressedChannelUp();
	void pressedChannelDn();
	void changeTableItem();
	void pressedAddPreset();
	void pressedDelPreset();
	void pressedApplyPreset();
	void changePreset();
	void changeZoomSpin();

public:
	cPanel(QWidget * parent = 0, Qt::WFlags f = 0);
	~cPanel();
	bool PresetAdded;

signals:
	void setBrightness(int);
	void setContrast(int);
	void setSaturation(int);
	void setZoom(double);
	void setDescr();
	void setFreq(QString);
	void setNorm(QString);
	void setCheckBoxes();
	void setDefaultSize();
	void setCurrentSize();
	void ChannelsScan();
	void ChannelsScanStop();
	void ChannelAdd();
	void ChannelDel();
	void ChannelUp();
	void ChannelDn();
	void ChannelChangeFromTable();
	void savePreset(int index);
	void loadPreset(int index);
	void deletePreset(int index);
};
#endif
