#include "fm.h"

#include <src/cfg_file.cpp>
#include <src/channels_manipulation.cpp>
#include <src/pid_files.cpp>
#include <src/fullscreen.cpp>
#include <src/tv_view.cpp>
#include <src/tv_record.cpp>
#include <src/other_func.cpp>

fMain::fMain( QWidget * parent, Qt::WFlags f): QWidget(parent, f){
// При запуске программы
	setupUi(this);
	runThis=false;
	HomeDir=QDir::homePath();
	loadPix=QPixmap (HomeDir+BACKGROUND_PICTURE);
	hide();
	confPanel=new cPanel(this,Qt::Window);
	startRecord=new sr(this,Qt::Window);
	dial=new fDial (this,Qt::Dialog);
	device="0";
	TemporaryPreset=false;
	configLoad (device);
	videoFrame = new VideoFrame (this);
	HPrior=false;
	dOff=false;
	CommandRec=false;
	prefChar=FILE_PREFIX_MANUAL"-";
	SelectChannel="";

	timerKill = new QTimer (this);
	connect (timerKill, SIGNAL (timeout()), SLOT (timerKillEvent()));

#include <src/command_params.cpp>

	confPanel->setPalette (palette());
	startRecord->setPalette (palette());
	dial->setPalette (palette());
	ChannelsTableFill();

	QString dbusNameP="org.kochkin.tvok";
	QString dbusName=dbusNameP+"-"+QString::number(qApp->applicationPid());
	QDBusConnection connection = QDBusConnection::connectToBus(QDBusConnection::SessionBus, dbusName);
	if (!connection.registerService(dbusName)) {
		exit (tr ("Can not Work Program. DBUS service not registered."));
		} else {
		oprint (tr ("DBUS service registered as")+" "+dbusName);
		}
	if (!connection.registerObject("/Interface", this, QDBusConnection::ExportAllContents)) {
		oprint (tr ("Can not Work Program. DBUS object not registered."));
		} else {
		oprint (tr ("DBUS object registered."));
		}

	QDBusConnection connectionP = QDBusConnection::connectToBus(QDBusConnection::SessionBus, dbusNameP+device);
	if (!connectionP.registerService(dbusNameP+device)) {
		oprint (tr ("DBUS service not registered")+" - "+dbusNameP+device+" - "+tr ("not critical."));
		} else {
		oprint (tr ("DBUS service registered as")+" "+dbusNameP+device);
		}
	if (!connectionP.registerObject("/Interface", this, QDBusConnection::ExportAllContents)) {
		oprint (tr ("DBUS object not registered")+" - "+dbusNameP+device+" - "+tr ("not critical."));
		}
	
	PidFileSaved.setFileName (HomeDir+"/.tvok/tvokpid"+device);
	PidCheck();
	if (!PidExists){
		openV4Ldevice();
		getStandards();
		FullScreenFlag=false;
		confPanel->cpInformation->append (COPYRIGHT);
		getInfo();
		confPanel->cpInformation->append (tr ("Tuner")+":\t"+Info.card);
		confPanel->cpInformation->append (tr ("Driver")+":\t"+Info.driver);
		confPanel->cpInformation->append (tr ("Input")+":\t"+Info.input);
			
		videoFrame->setFrameStyle(QFrame::Panel | QFrame::Sunken);
		videoFrameId=QString::number((int) videoFrame->winId());
		frControl->move ((width()-frControl->width())/2,height()-frControl->height()-2);
		videoFrame->move(2,2);
		videoFrame->resize(width()-4, height()-40);
		videoFrame->setMouseTracking (true);

		connect (videoFrame, SIGNAL (doubleClicked()), this, SLOT (toggleFullScreen()));
		connect (videoFrame, SIGNAL (wheelMove(int)), this, SLOT (deltaChannel(int)));
		connect (videoFrame, SIGNAL (contextMenu()), this, SLOT (contextMenu()));
		connect (confPanel, SIGNAL (setBrightness(int)), this, SLOT (setBrightness(int)));
		connect (confPanel, SIGNAL (setContrast(int)), this, SLOT (setContrast(int)));
		connect (confPanel, SIGNAL (setSaturation(int)), this, SLOT (setSaturation(int)));
		connect (confPanel, SIGNAL (setZoom(double)), this, SLOT (setZoom(double)));
		connect (confPanel, SIGNAL (setDescr()), this, SLOT (setDescr()));
		connect (confPanel, SIGNAL (setFreq(QString)), this, SLOT (setFreq(QString)));
		connect (confPanel, SIGNAL (setNorm(QString)), this, SLOT (setNorm(QString)));
		connect (confPanel, SIGNAL (setCheckBoxes()), this, SLOT (setCheckBoxes()));
		connect (confPanel, SIGNAL (setDefaultSize()), this, SLOT (setDefaultSize()));
		connect (confPanel, SIGNAL (setCurrentSize()), this, SLOT (setCurrentSize()));
		connect (confPanel, SIGNAL (ChannelsScan()), this, SLOT (ChannelsScan()));
		connect (confPanel, SIGNAL (ChannelAdd()), this, SLOT (ChannelAdd()));
		connect (confPanel, SIGNAL (ChannelDel()), this, SLOT (ChannelDel()));
		connect (confPanel, SIGNAL (ChannelUp()), this, SLOT (ChannelUp()));
		connect (confPanel, SIGNAL (ChannelDn()), this, SLOT (ChannelDn()));
		connect (confPanel, SIGNAL (ChannelChangeFromTable()), this, SLOT (ChannelChangeFromTable()));
		connect (confPanel, SIGNAL (savePreset(int)), this, SLOT (savePreset(int)));
		connect (confPanel, SIGNAL (loadPreset(int)), this, SLOT (loadPreset(int)));
		connect (confPanel, SIGNAL (deletePreset(int)), this, SLOT (deletePreset(int)));
	
		timer500ms = new QTimer (this);
		timerChannelChange = new QTimer (this);
		connect (timer500ms, SIGNAL (timeout()), SLOT (timer500()));
		tSelectChannel = new QTimer (this);
		connect (tSelectChannel, SIGNAL (timeout()), SLOT (tChSelectTimeout()));
		
		ChannelChange (CurrentChannel-1);
		}
	if (dOff){
		videoFrame->setVisible (false);
		resize (width(),frControl->height()+4);
		}
	RecordCancelled=false;
	if (CommandRec && !PidExists){
		int res=0;
		if (!runThis){
			res=execDialog ("TVOK - "+tr ("Record starting"),\
				QPixmap (":/64x64/xine.png"),\
				tr ("Tuner")+": ["+device+"] "+Info.card+"\n"+\
				tr ("Channel")+": "+arChStr+"\n"+\
				tr ("Transmission")+": "+arName+"\n"+\
				tr ("Duration")+": "+arTime, tr ("Cancel recording"),\
				tr ("Start recording"), 10000);
				}
		if (res == 1) RecordCancelled=true;
		if (RecordCancelled){
			exit (tr ("Recording cancelled by user."));
			} else {
			show();
			CurrentChannel=arCh+1;
			timer500ms->start( 500);
			recordStart();
			}
		}
	else {
		if (!PidExists){
			show();
			timer500ms->start (500);
			if (!dOff) viewStart();
			}
		}
}

fMain::~fMain(){
// При выходе из программы
	if (!PidExists && !RecordCancelled){
		viewStop();
		recordViewStop();
		recordStop();
		configSave();
		PidDelete ();
		}
}
