#include "build_number.h"
#define VERSION VERSION_NUMBER"-"BUILD_NUMBER
#define COPYRIGHT "TVOK. TV viewer/recorder for KDE 4 (based on MPlayer/Mencoder).\nVersion "VERSION". Copyright (C) Oleg Kochkin 2009-2011. License GPL.\n"

// Эти определения должны быть вынесены в настройки
// Пауза перед повторной настройкой канала во время просмотра
#define RECHANNEL_MS_VIEW 2000
// Пауза перед повторной настройкой канала во время записи
#define RECHANNEL_MS_RECORD 2000
// Время показа фоновой картинки между переключеним каналов
#define VIDEO_PANEL_OFF 600
// Фоновая картинка
#define BACKGROUND_PICTURE "/.tvok/background.png"
// Префикс файла для ручной записи
#define FILE_PREFIX_MANUAL "M"
// Префикс файла для записи по расписанию
#define FILE_PREFIX_COMMAND "C"
// Задержка в мс при вводе номера канала посредством DBUS
#define WAIT_NEXT_DIGIT_DBUS 2000

#ifndef FM_H
#define FM_H

#include <QtDBus>
#include <QtGui>
#include "ui_fmain.h"
#include "videoframe.h"
#include "cpanel.h"
#include "sr.h"
#include "fdial.h"
#include <linux/videodev2.h>
#include <sys/ioctl.h>
#include <fcntl.h>

class fMain : public QWidget, public Ui::Fm
{
Q_OBJECT
public:
	void getStandards();
	void openV4Ldevice();
	void oprint(QString str);
	fMain( QWidget * parent = 0, Qt::WFlags f = 0 );
	~fMain();

	QProcess prView, prRecord, prRecordView, prScan;
	VideoFrame *videoFrame;
	QString videoFrameId;
	Qt::WindowStates winstate;
	QRect winrect;
	bool FullScreenFlag;
	struct Channel{
		QString 	freq;
		QString		descr;
		QString		norm;
		int				brightness;
		int				contrast;
		int				saturation;
		bool			enabled;
		QPixmap		icon;
		int				groupId;
		double		zoom;
	};
	struct sInfo
		{
			QString card;
			QString driver;
			QString input;
		};
	sInfo Info;
	Channel currentChannel;
	QList<Channel> Channels;
	QString device, HomeDir, prefChar, arChStr, arName, arTime, sVDevice, sStartDateTime, FileRec;
	QString otherMode, otherChannel, otherTransmission, SelectChannel;
	bool ResizeEnabled, RVideoFiltersEnabled, VVideoFiltersEnabled, CommandRec, dOff, HPrior, PidExists;
	bool RAudioFiltersEnabled, mplayerOsd;
	bool tik, RecordCancelled, otherPriority, TemporaryPreset, runThis;
	int CurrentChannel, LastChannel, VDevice, arCh, attempt, tunerWidth, tunerHeight;
	v4l2_standard Standards[32];
	int standardsCount, channelId;
	QPoint mousePosition;
	QFile PidFileSaved;
	cPanel *confPanel;
	sr *startRecord;
	fDial *dial;
	QDateTime StartDateTime;
	QProgressDialog progressRecord;
	QTimer *timer500ms, *timerChannelChange, *timerChannelChange2, *timerKill, *tSelectChannel;
	QString Pids[5];
	QPixmap backPix,loadPix;

private slots:
	void setCheckBoxes();
	void setDescr();
	void configSave();
	void configLoad(QString device);
	void PidCheck();
	void timer500();
	void timerKillEvent();
	void tChSelectTimeout();
	void configPanel();
	void deltaChannel(int delta);
	int idChannel (QString descr);
	void PidSave();
	void PidDelete();
	void viewStop();
	void viewStart();
	void recordViewStart();
	void recordViewStop();
//	void recordViewXineStart();
	void setFreq(const QString& freq);
	void setNorm(const QString& norm);
	void bRecPressed();
	void setDefaultSize();
	void setCurrentSize();
	void rechangeChannel();
	void videoFrameOn ();
	void videoFrameOff ();
	int execDialog (QString Caption, QPixmap Picture, QString Text, QString Button1, QString Button2, int Timeout);
	void contextMenu();
	void setContrast(const int value);
	void setBrightness(const int value);
	void setSaturation(const int value);
	void setZoom(const double value);
	void ChannelChangeByName (QString descr);
	void ChannelChange(int id);
	void ChannelChangeDelay();
	void ChannelsScan();
	void ChannelsScanStop();
	int ChannelExists (QString freq);
	void ChannelsTableFill();
	void ChannelAdd();
	void ChannelDel();
	void ChannelUp();
	void ChannelDn();
	void ChannelChangeFromTable();
	void loadPreset(int index);
	void savePreset(int index);
	void deletePreset(int index);
	int getIdPresetFromName(QString name);
	void getInfo();

public slots:
	bool getPriority();
	QString getMode();
	QString getChannel();
	int getChannelNum();
	QString getTransmission();
	QString getDevice();
	double getFullScreenZoom();
	void exit(QString mess);
	void serviceExit(QString mess);
  void toggleFullScreen();
  void ChannelNext();
  void ChannelPrev();
  void ChannelNum(QString ch);
	void FullScreenZoom (QString zoom);
	void FullScreenZoomSet (QString zoom);
	void recordStart();
	void recordStop();
	void recordToggle();
	
private:
	void resizeEvent (QResizeEvent *);
	void paintEvent (QPaintEvent *);
	void runThisInstance();
};
#endif




