#include <src/fm.h>

void fMain::resizeEvent (QResizeEvent *){
// При изменении размера основной формы программы
	if (!FullScreenFlag){
		if (dOff) frControl->move (2,2);
		else frControl->move ((width()-frControl->width())/2,height()-frControl->height()-2);
		videoFrame->move(2,2);
		videoFrame->resize(width()-4, height()-40);
	}
}

void fMain::exit(QString mess){
// Выход из программы
	if (prRecord.state() != QProcess::Running) serviceExit(mess);
}

void fMain::serviceExit(QString mess){
// Служебный выход из программы
	oprint (tr ("Exit message")+": "+mess);
	QTimer *timer0 = new QTimer (this);
	connect (timer0, SIGNAL(timeout()), SLOT(close()));
	timer0->start (1000);
}

void fMain::configPanel(){
// Показ панели конфигурации
	confPanel->setWindowTitle ("TVOK ["+device+"] "+tr ("Configuration"));
	confPanel->show();
}


void fMain::oprint(QString str){
//		NowDateTime=QDateTime::currentDateTime();
	QString NowDateTime=QDateTime::currentDateTime().toString ("yyyy.MM.dd-hh:mm:ss.zzz");
	QString mess=NowDateTime+" - "+str;
	qDebug()<<mess;
}

void fMain::contextMenu(){
// Контекстное меню на видеоокне
	if (prRecord.state() != QProcess::Running){
		QMenu *contextMenu = new QMenu (this);
		//QMenu *groupMenu = new QMenu (this);
		//groupMenu->addAction (Channels[0].icon, Channels[0].descr);
		//groupMenu->setTitle (tr ("Groups of channels"));
		//groupMenu->setPalette (palette());
		//contextMenu->addMenu(groupMenu);
		contextMenu->setPalette (palette());
		QAction *em = new QAction (this);
		for (int i=0;i<LastChannel;i++) contextMenu->addAction (Channels[i].icon, Channels[i].descr);
		em = contextMenu->exec (QCursor::pos());
		if (em != NULL) ChannelChangeByName (em->text());
	}
}

bool fMain::getPriority(){
	return HPrior;
}

QString fMain::getMode(){
	QString ret="VIEWING";
	if (prRecord.state()==QProcess::Running) ret="RECORDING";
	return ret;
}

QString fMain::getChannel(){
	return Channels[CurrentChannel-1].descr;
}

QString fMain::getTransmission(){
	return arName;
}

QString fMain::getDevice(){
	return device;
}

void fMain::setCheckBoxes(){
//	if (confPanel->cpCropEnabled->checkState()==Qt::Checked) CropEnabled=true;
//	else CropEnabled=false;
	if (confPanel->cpResizeEnabled->checkState()==Qt::Checked) ResizeEnabled=true;
	else ResizeEnabled=false;
	if (confPanel->cpRVideoFiltersEnabled->checkState()==Qt::Checked) RVideoFiltersEnabled=true;
	else RVideoFiltersEnabled=false;
	if (confPanel->cpVVideoFiltersEnabled->checkState()==Qt::Checked) VVideoFiltersEnabled=true;
	else VVideoFiltersEnabled=false;
	if (confPanel->cpRAudioFiltersEnabled->checkState()==Qt::Checked) RAudioFiltersEnabled=true;
	else RAudioFiltersEnabled=false;
}

void fMain::bRecPressed(){
	if (prRecord.state()==QProcess::Running){
		recordStop();
		if (CommandRec) exit (tr ("Recording interrupt by user"));
		}
	else recordStart();
}

void fMain::recordToggle() {bRecPressed();}

void fMain::setDefaultSize(){
	resize (confPanel->cpDefaultWidth->value(), confPanel->cpDefaultHeight->value());
}

void fMain::setCurrentSize(){
	confPanel->cpDefaultWidth->setValue(width());
	confPanel->cpDefaultHeight->setValue(height());
}

void fMain::rechangeChannel(){
	ChannelChange (CurrentChannel-1);
}

void fMain::timer500(){
// Таймер каждые полсекунды
	if (prView.state()==QProcess::Running || prRecordView.state()==QProcess::Running){
		lView->setPixmap (QPixmap (":/icons/diod-blue-on.png"));
		}	else {
		lView->setPixmap (QPixmap (":/icons/diod-blue-off.png"));
		}
	if (prRecord.state()==QProcess::Running){
		bToggleRecord->setIcon (QIcon(":/icons/stop.png"));
		backLabel->setPixmap (QPixmap (":/icons/disp_red.png"));
		confPanel->cpStartScan->setEnabled (false);
		if (tik){
			QFile file(FileRec);
			setWindowTitle (Channels[CurrentChannel-1].descr+" [R] ("+QString::number(file.size()/1048576)+" Mb) (TVOK-"+device+")");
			lRecord->setPixmap (QPixmap (":/icons/diod-red-on.png"));
			} else {
			lRecord->setPixmap (QPixmap (":/icons/diod-red-off.png"));
			}
		} else {
		confPanel->cpStartScan->setEnabled (true);
		bToggleRecord->setIcon (QIcon(":/icons/rec.png"));
		backLabel->setPixmap (QPixmap (":/icons/disp_blue.png"));
		lRecord->setPixmap (QPixmap (":/icons/diod-red-off.png"));
		if (CommandRec){
			timer500ms->stop();
			viewStop();
			recordStop();
			exit (tr ("Recording finished."));
			}
		}
	if (prRecordView.state()==QProcess::Running){
		}	else {
		}
	if (tik) tik=false;
	else tik=true;
}

int fMain::execDialog (QString Caption, QPixmap Picture, QString Text, QString Button1, QString Button2, int Timeout){
// Запуск модального диалога
	dial->setWindowTitle (Caption);
	dial->Picture->setPixmap (Picture);
	dial->Text->setText (Text);
	dial->Button1->setText (Button1);
	dial->Button2->setText (Button2);
	dial->Timeout=Timeout;
	return dial->exec();
}

void fMain::paintEvent (QPaintEvent *){
// Используется для вывода фоновой картинки при переключении каналов
//	if (!loadPix.isNull()){
//		backPix=loadPix.scaled (videoFrame->width(),videoFrame->height());
//		QPainter painter (this);
//		painter.drawTiledPixmap (videoFrame->x(),videoFrame->y(),videoFrame->width(),videoFrame->height(),backPix);
//		}
	if (!FullScreenFlag) blackFrame->setGeometry (videoFrame->geometry());
}

void fMain::ChannelsTableFill(){
// Заполнение таблицы каналов
	while (confPanel->cpChannelsTable->rowCount()>0) confPanel->cpChannelsTable->removeRow(0);
	confPanel->cpChannelsTable->hideColumn (0);
	confPanel->cpChannelsTable->hideColumn (1);
	QTableWidgetItem *item = 0;
	for (int i=0;i<LastChannel;i++){
		confPanel->cpChannelsTable->insertRow (confPanel->cpChannelsTable->rowCount());
		confPanel->cpChannelsTable->setRowHeight (i,16);
		item = new QTableWidgetItem(QIcon(Channels[i].icon),"");
		confPanel->cpChannelsTable->setItem (i,2,item);
		item = new QTableWidgetItem(Channels[i].descr);
		confPanel->cpChannelsTable->setItem (i,3,item);
		item = new QTableWidgetItem(Channels[i].norm);
		confPanel->cpChannelsTable->setItem (i,4,item);
		item = new QTableWidgetItem(Channels[i].freq);
		confPanel->cpChannelsTable->setItem (i,5,item);
		}
	confPanel->cpChannelsTable->resizeColumnsToContents ();
}

void fMain::ChannelAdd(){
// Добавление канала
	LastChannel++;
	Channel AddCh;
	AddCh.brightness=0;
	AddCh.contrast=0;
	AddCh.saturation=0;
	AddCh.descr=tr ("No name")+"-"+QString::number (LastChannel);
	AddCh.freq="135.25";
	AddCh.norm="PAL";
	AddCh.icon=NULL;
	AddCh.enabled=true;
	AddCh.groupId=0;
	Channels.append (AddCh);
	ChannelsTableFill();
	confPanel->cpChannelsTable->selectRow (confPanel->cpChannelsTable->rowCount()-1);
}

void fMain::ChannelDel(){
// Удаление канала
	int curRow=confPanel->cpChannelsTable->currentRow ();
	for (int i=curRow;i<LastChannel-1;i++){
		Channels[i]=Channels[i+1];
		}
	LastChannel--;
	confPanel->cpChannelsTable->removeRow (curRow);
	Channels.removeAt (curRow);
}

void fMain::ChannelUp(){
// Перемещение канала в таблице вверх
	if (confPanel->cpChannelsTable->currentRow() > 0){
		Channel ch;
		int curRow=confPanel->cpChannelsTable->currentRow();
		ch=Channels[curRow];
		Channels[curRow]=Channels[curRow-1];
		Channels[curRow-1]=ch;
		ChannelsTableFill();
		confPanel->cpChannelsTable->selectRow (curRow-1);
		}
}

void fMain::ChannelDn(){
// Перемещение канала в таблице вниз
	if (confPanel->cpChannelsTable->currentRow() < LastChannel-1){
		Channel ch;
		int curRow=confPanel->cpChannelsTable->currentRow();
		ch=Channels[curRow];
		Channels[curRow]=Channels[curRow+1];
		Channels[curRow+1]=ch;
		ChannelsTableFill();
		confPanel->cpChannelsTable->selectRow (curRow+1);
		}
}

int fMain::getIdPresetFromName(QString name){
	int id=0;
	for (int i=0;i<confPanel->cpPresets->count();i++){
		if (confPanel->cpPresets->itemText(i) == name){
			id=i;
			}
		}
	return id;
}

void fMain::getInfo(){
	QString s;
// Название устройства
	v4l2_capability sDev;
	ioctl(VDevice, VIDIOC_QUERYCAP, &sDev);
	s.sprintf ("%s",sDev.card);
	Info.card=s;
	s.sprintf ("%s",sDev.driver);
	Info.driver=s;
// Название входа
	v4l2_input sInput;
	int index;
	ioctl(VDevice, VIDIOC_G_INPUT, &index);
	sInput.index=index;
	ioctl(VDevice, VIDIOC_ENUMINPUT, &sInput);
	s.sprintf ("%s",sInput.name);
	Info.input=s;
// Разрешение тюнера
	v4l2_cropcap cropcap;
	cropcap.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
	ioctl (VDevice, VIDIOC_CROPCAP, &cropcap);
	tunerWidth=cropcap.defrect.width;
	tunerHeight=cropcap.defrect.height;
}

double fMain::getFullScreenZoom(){
	return Channels[CurrentChannel-1].zoom;
}

int fMain::getChannelNum(){
	return CurrentChannel;
}
