#include <src/fm.h>

void fMain::PidSave(){
// Запись PID файла
	if (PidFileSaved.open (QIODevice::WriteOnly)){
		if (!PidExists){
			QTextStream stream (&PidFileSaved);
			stream << qApp->applicationPid() << "\n";
			stream << prView.pid () << "\n";		// Просмотр
			stream << prRecordView.pid () << "\n";		// Просмотр при записи
			stream << prRecord.pid () << "\n";;		// Запись
			stream << HPrior << "\n";
			PidFileSaved.close();
			oprint (tr ("PID file saved."));
			}
		}
}

void fMain::PidDelete(){
// Удаление PID файла
 if (!PidExists){
	PidFileSaved.remove();
	oprint (tr ("PID file deleted."));
	}
}

void fMain::PidCheck(){
	QString otherAbout;
	QString thisAbout="";
	if (CommandRec) thisAbout=tr ("Information about allready running instance")+":\n\t"+\
		tr ("Channel")+": "+arChStr+", "+\
		tr ("Transmission")+": "+arName+", "+\
		tr ("Duration")+": "+arTime;
	int PidsCount=0;
	oprint (tr ("PID file check."));
	PidExists=false;
	if (PidFileSaved.exists()){
// Файл существует
// Что-то уже запущено
		oprint (tr ("PID file already exists."));
		if (PidFileSaved.open(QIODevice::ReadOnly)){
			QTextStream stream (&PidFileSaved);
			QString line;
			while (!stream.atEnd()){
				line = stream.readLine();
				Pids[PidsCount]=line;
				PidsCount++;
				}
			PidFileSaved.close();
			QDBusInterface otherInstance ("org.kochkin.tvok-"+Pids[0], "/Interface");
			QDBusReply<bool> otherInstancePriority = otherInstance.call ("getPriority");
			otherPriority=otherInstancePriority.value();
			QDBusReply<QString> otherInstanceMode = otherInstance.call ("getMode");
			if (otherInstanceMode.value() == "VIEWING") otherMode=tr ("Viewing");
			if (otherInstanceMode.value() == "RECORDING") otherMode=tr ("Recording");
			QDBusReply<QString> otherInstanceChannel = otherInstance.call ("getChannel");
			otherChannel=otherInstanceChannel.value();
			QDBusReply<QString> otherInstanceTransmission = otherInstance.call ("getTransmission");
			if (otherInstanceTransmission.value() != "") otherTransmission="\n"+tr ("Transmission")+": "+otherInstanceTransmission.value(); 
			else otherTransmission="";
			otherAbout="\n\n"+tr ("Information about running instance")+":\n\t"+\
				tr ("Mode")+": "+otherMode+", "+\
				tr ("Channel")+": "+otherChannel+\
				otherTransmission;
			}
	if (HPrior) {
// Данный экземпляр запущен с высоким приоритетом
		oprint (tr ("This copy of the program is running with high priority."));
			if (!otherPriority){
// Ранее запущеный экземпляр имеет низкий приоритет
// Этот высокий
// Диалог - оставить уже запущенный экземпляр или запустить этот
			int res=execDialog ("TVOK ["+device+"] "+tr ("Previously running a copy of the program is low priority."),\
				QPixmap (":/64x64/error.png"),\
				tr ("Leave already running instance or run it?")+otherAbout+"\n"+thisAbout,
				tr ("Leave already running"),\
				tr ("Run this instance"), 20000);
			if (res != 1){
// Запустить этот экземпляр
				oprint (tr ("Previously running a copy of the program is low priority."));
				runThisInstance();
				} else {
// Оставить запущенный экземпляр
					PidExists=true;
					exit (tr ("Starting cancelled by user."));
					}
				} else {
// Ранее запущеный экземпляр имеет высокий приоритет
// Этот высокий
					int res=execDialog ("TVOK ["+device+"] "+tr ("Previously running a copy of the program is high priority."),\
						QPixmap (":/64x64/error.png"),\
						tr ("Leave already running instance or run it?")+otherAbout+"\n"+thisAbout,
						tr ("Run this instance"),\
						tr ("Leave already running"), 20000);
					if (res == 1) runThisInstance();
					else {
						PidExists=true;
						exit (tr ("Previously running a copy of the program is high priority. Start programm canceled."));
						}
				}
			} else {
// Данный экземпляр запущен с низким приоритетом
// Запущенный - любой
			int res=execDialog ("TVOK ["+device+"] "+tr ("There is a running instance of the program."),\
				QPixmap (":/64x64/error.png"),\
				tr ("Leave already running instance or run it?")+otherAbout+"\n"+thisAbout,
				tr ("Run this instance"),\
				tr ("Leave already running"), 20000);
			if (res == 1) runThisInstance();
			else {
				PidExists=true;
				oprint (tr ("This copy of the program is running with low priority."));
				exit (tr ("Running the program is canceled. PID file already exists."));
				}
			}
		}
}

void fMain::runThisInstance(){
// Запустить этот экземпляр
	oprint (tr ("Send DBUS message for close previously running instance."));
	QDBusInterface other ("org.kochkin.tvok-"+Pids[0], "/Interface");
	other.call ("serviceExit", tr ("Closed from other copy."));
	attempt=1;

	timerKill->start (1000);
	execDialog ("TVOK ["+device+"] "+tr (""),\
		QPixmap (":/64x64/error.png"),\
		tr ("Running instance of the attempt to close the program"),
		tr (""),\
		tr (""), 9000);
	timerKill->stop();

	if (attempt>9) {
// Принудительное завершение процессов, указанных в PID файле.
	oprint (tr ("Forcing the completion of the previous instance and delete PID file."));
	QProcess kill;
	for (int i=1;i<=4;i++){
		if ((Pids[i] != "-1") && (Pids[i] != "0")){
			QString killstring="kill -9 "+Pids[i];
			kill.start (killstring);
			kill.waitForStarted (500);
			kill.waitForFinished (500);
			}
		}
	PidFileSaved.remove();
	}
	runThis=true;
}

void fMain::timerKillEvent(){
	if (PidFileSaved.exists() && attempt<11){
		oprint (tr ("Running instance of the attempt to close the program")+" "+QString::number(attempt));
		attempt++;
		}
}
