#include <src/fm.h>

void fMain::recordStart(){
	if (!PidExists && !RecordCancelled){
		QString devId="";
		QString aDevice=confPanel->cpAudioInput->text();
		if (confPanel->cpAudioDev->currentText()=="ALSA") devId=":alsa";
		QString frun=":norm="+Channels[CurrentChannel-1].norm+":freq="+Channels[CurrentChannel-1].freq;
		StartDateTime=QDateTime::currentDateTime();
		sStartDateTime=StartDateTime.toString ("yyMMdd-hhmmss");
		FileRec=confPanel->cpRecordDir->text()+"/"+prefChar+sStartDateTime+"-"+device+"-"+Channels[CurrentChannel-1].descr;
		if (CommandRec){FileRec=FileRec+"-"+arName;}
		FileRec=FileRec+confPanel->cpFileExt->text();
		viewStop();
		QString command="mencoder";
		if (CommandRec){
			command=command+" -endpos "+arTime;
			}
		command=command+" -quiet -tv";
		QString vsize=":width="+QString::number(tunerWidth)+":height="+QString::number(tunerHeight);
		command=command+" device="+confPanel->cpVideoDevicePrefix->text()+device+devId+":adevice="+aDevice+\
			":amode=1:audiorate="+confPanel->cpAudioFreq->text()+":fps="+confPanel->cpFps->text()+vsize+frun;
// Аудиофильтры
		QString audiofilters="";
		if (confPanel->cpRAudioFiltersEnabled->checkState()==Qt::Checked) audiofilters=","+confPanel->cpRAudioFilters->text();
		command=command+" -af volume="+confPanel->cpAudioVolume->text()+audiofilters;
		command=command+" -ovc "+confPanel->cpVideoCodec->text();
		command=command+" -audio-delay "+confPanel->cpAudioDelay->text()+" -oac "+confPanel->cpAudioCodec->text();

		QString vfilters=" ";
// Добавление видеофильтров
		if (confPanel->cpRVideoFiltersEnabled->checkState()==Qt::Checked){vfilters=confPanel->cpVideoFilters->text();}
// Добавление обрезки
		QString crop="scale="+QString::number(confPanel->cpSizeWidth->value())+":"+QString::number(confPanel->cpSizeHeight->value())+\
			",crop="+QString::number(confPanel->cpSizeWidth->value()-(confPanel->cpCropLeftR->value()+confPanel->cpCropRightR->value()))+\
			":"+QString::number(confPanel->cpSizeHeight->value()-(confPanel->cpCropTopR->value()+confPanel->cpCropBottomR->value()))+\
			":"+QString::number(confPanel->cpCropLeftR->value())+":"+QString::number(confPanel->cpCropTopR->value());
// Если включен CropEnabled
//		if (confPanel->cpCropEnabled->checkState()==Qt::Checked){
// Если видеофильты не были добавлены ранее
			if (vfilters == " ") vfilters=crop;
// Если видеофильтры были добавлены ранее
			else vfilters=vfilters+","+crop;
//				}
// Если есть видеофильтры
		if (vfilters != " ") vfilters=" -vf "+vfilters;
		command=command+vfilters+" "+confPanel->cpROtherParameters->text()+" -o \""+FileRec+"\" tv://";
		prRecord.start (command);
		prRecord.waitForStarted (3000);
		if (not dOff) QTimer::singleShot (confPanel->cpPDelay->value(), this, SLOT (recordViewStart()));
		QTimer::singleShot (RECHANNEL_MS_RECORD, this, SLOT (rechangeChannel()));
		oprint (tr ("Recording started")+": \""+command+"\"");
		PidSave();
	}
}

void fMain::recordStop(){
// Остановка записи
	if (!PidExists){
		if (prRecord.state()==QProcess::Running){
			recordViewStop();
			QString mess=tr ("normal.");
			prRecord.terminate ();
			if (! prRecord.waitForFinished (5000)){
				prRecord.kill ();
				mess=tr ("abnormally. Not critical.");
				}
			if (!CommandRec) QTimer::singleShot (500, this, SLOT (viewStart()));
			oprint (tr ("Recording stopped")+" "+mess);
			}
		}
}
